## ESourceSelector ESourceSelector |

## Functions

GtkWidget * | e_source_selector_new ()
ESourceRegistry * | e_source_selector_get_registry ()
const gchar * | e_source_selector_get_extension_name ()
gboolean | e_source_selector_get_show_colors ()
void | e_source_selector_set_show_colors ()
gboolean | e_source_selector_get_show_icons ()
void | e_source_selector_set_show_icons ()
gboolean | e_source_selector_get_show_toggles ()
void | e_source_selector_set_show_toggles ()
void | e_source_selector_select_source ()
void | e_source_selector_unselect_source ()
void | e_source_selector_select_exclusive ()
void | e_source_selector_select_all ()
gboolean | e_source_selector_source_is_selected ()
GList * | e_source_selector_get_selection ()
guint | e_source_selector_count_total ()
guint | e_source_selector_count_selected ()
void | e_source_selector_edit_primary_selection ()
ESource * | e_source_selector_ref_primary_selection ()
void | e_source_selector_set_primary_selection ()
ESource * | e_source_selector_ref_source_by_iter ()
ESource * | e_source_selector_ref_source_by_path ()
void | e_source_selector_queue_write ()
void | e_source_selector_update_row ()
void | e_source_selector_update_all_rows ()
void | e_source_selector_set_source_tooltip ()
gchar * | e_source_selector_dup_source_tooltip ()
void | e_source_selector_set_source_is_busy ()
gboolean | e_source_selector_get_source_is_busy ()
gboolean | e_source_selector_manage_groups ()
gboolean | e_source_selector_save_groups_setup ()
void | e_source_selector_load_groups_setup ()

## Types and Values

#define | E_SOURCE_SELECTOR_GROUPS_SETUP_NAME

## Description

## Functions

### e_source_selector_new ()

    GtkWidget *
    e_source_selector_new (ESourceRegistry *registry,
                           const gchar *extension_name);

`e_source_selector_new` is deprecated and should not be used in newly-written code.

Displays a list of sources from `registry` having an extension named `extension_name` . The sources are grouped by backend or groupware account, which are described by the parent source.

#### Parameters

registry | an ESourceRegistry |
extension_name | the name of an ESource extension |

#### Returns

a new ESourceSelector

### e_source_selector_get_registry ()

    ESourceRegistry *
    e_source_selector_get_registry (ESourceSelector *selector);

`e_source_selector_get_registry` is deprecated and should not be used in newly-written code.

Returns the ESourceRegistry that `selector` is getting sources from.

#### Parameters

selector | an ESourceSelector |

#### Returns

an ESourceRegistry

Since: 3.6

### e_source_selector_get_extension_name ()

    const gchar *
    e_source_selector_get_extension_name (ESourceSelector *selector);

`e_source_selector_get_extension_name` is deprecated and should not be used in newly-written code.

Returns the extension name used to filter which sources are displayed.

#### Parameters

selector | an ESourceSelector |

#### Returns

the ESource extension name

Since: 3.6

### e_source_selector_get_show_colors ()

    gboolean
    e_source_selector_get_show_colors (ESourceSelector *selector);

`e_source_selector_get_show_colors` is deprecated and should not be used in newly-written code.

Returns whether colors are shown next to data sources.

#### Parameters

selector | an ESourceSelector |

#### Returns

`TRUE` if colors are being shown

Since: 3.6

### e_source_selector_set_show_colors ()

    void
    e_source_selector_set_show_colors (ESourceSelector *selector,
                                       gboolean show_colors);

`e_source_selector_set_show_colors` is deprecated and should not be used in newly-written code.

Sets whether to show colors next to data sources.

#### Parameters

selector | an ESourceSelector |
show_colors | whether to show colors |

Since: 3.6

### e_source_selector_get_show_icons ()

    gboolean
    e_source_selector_get_show_icons (ESourceSelector *selector);

`e_source_selector_get_show_icons` is deprecated and should not be used in newly-written code.

Returns whether icons are shown next to data sources.

Generally the icon shown will be based on the presence of a backend-based extension, such as ESourceAddressBook or ESourceCalendar. For ESource instances with no such extension, no icon is shown.

#### Parameters

selector | an ESourceSelector |

#### Returns

`TRUE` if icons are being shown

Since: 3.12

### e_source_selector_set_show_icons ()

    void
    e_source_selector_set_show_icons (ESourceSelector *selector,
                                      gboolean show_icons);

`e_source_selector_set_show_icons` is deprecated and should not be used in newly-written code.

Sets whether to show icons next to data sources.

Generally the icon shown will be based on the presence of a backend-based extension, such as ESourceAddressBook or ESourceCalendar. For ESource instances with no such extension, no icon is shown.

#### Parameters

selector | an ESourceSelector |
show_icons | whether to show icons |

Since: 3.12

### e_source_selector_get_show_toggles ()

    gboolean
    e_source_selector_get_show_toggles (ESourceSelector *selector);

`e_source_selector_get_show_toggles` is deprecated and should not be used in newly-written code.

Returns whether toggles are shown next to data sources.

#### Parameters

selector | an ESourceSelector |

#### Returns

`TRUE` if toggles are being shown

Since: 3.6

### e_source_selector_set_show_toggles ()

    void
    e_source_selector_set_show_toggles (ESourceSelector *selector,
                                        gboolean show_toggles);

`e_source_selector_set_show_toggles` is deprecated and should not be used in newly-written code.

Sets whether to show toggles next to data sources.

#### Parameters

selector | an ESourceSelector |
show_toggles | whether to show toggles |

Since: 3.6

### e_source_selector_select_source ()

    void
    e_source_selector_select_source (ESourceSelector *selector,
                                     ESource *source);

`e_source_selector_select_source` is deprecated and should not be used in newly-written code.

Select `source` in `selector` .

#### Parameters

selector | An ESourceSelector widget |
source | An ESource. |

### e_source_selector_unselect_source ()

    void
    e_source_selector_unselect_source (ESourceSelector *selector,
                                       ESource *source);

`e_source_selector_unselect_source` is deprecated and should not be used in newly-written code.

Unselect `source` in `selector` .

#### Parameters

selector | An ESourceSelector widget |
source | An ESource. |

### e_source_selector_select_exclusive ()

    void
    e_source_selector_select_exclusive (ESourceSelector *selector,
                                        ESource *source);

`e_source_selector_select_exclusive` is deprecated and should not be used in newly-written code.

Select `source` in `selector` and unselect all others.

#### Parameters

selector | An ESourceSelector widget |
source | An ESource. |

Since: 2.30

### e_source_selector_select_all ()

    void
    e_source_selector_select_all (ESourceSelector *selector);

`e_source_selector_select_all` is deprecated and should not be used in newly-written code.

Selects all ESource-s in the `selector` .

#### Parameters

selector | An ESourceSelector widget |

Since: 3.20

### e_source_selector_source_is_selected ()

    gboolean
    e_source_selector_source_is_selected (ESourceSelector *selector,
                                          ESource *source);

`e_source_selector_source_is_selected` is deprecated and should not be used in newly-written code.

Check whether `source` is selected in `selector` .

#### Parameters

selector | An ESourceSelector widget |
source | An ESource. |

#### Returns

`TRUE` if `source` is currently selected, `FALSE` otherwise.

### e_source_selector_get_selection ()

    GList *
    e_source_selector_get_selection (ESourceSelector *selector);

`e_source_selector_get_selection` is deprecated and should not be used in newly-written code.

Returns a list of selected sources, i.e. those that were enabled through the corresponding checkboxes in the tree. The sources are ordered as they appear in `selector` .

The sources returned in the list are referenced for thread-safety. They must each be unreferenced with `g_object_unref()` when finished with them. Free the returned list itself with `g_list_free()`.

An easy way to free the list properly in one step is as follows:

    1
    g_list_free_full (list, g_object_unref);

#### Parameters

selector | an ESourceSelector |

#### Returns

a ordered list of selected sources

### e_source_selector_count_total ()

    guint
    e_source_selector_count_total (ESourceSelector *selector);

`e_source_selector_count_total` is deprecated and should not be used in newly-written code.

Counts how many ESource-s are shown in the `selector` .

#### Parameters

selector | an ESourceSelector |

#### Returns

How many ESource-s are shown in the `selector` .

Since: 3.20

### e_source_selector_count_selected ()

    guint
    e_source_selector_count_selected (ESourceSelector *selector);

`e_source_selector_count_selected` is deprecated and should not be used in newly-written code.

Counts how many ESource-s are selected in the `selector` .

#### Parameters

selector | an ESourceSelector |

#### Returns

How many ESource-s are selected in the `selector` .

Since: 3.20

### e_source_selector_edit_primary_selection ()

    void
    e_source_selector_edit_primary_selection
                                   (ESourceSelector *selector);

`e_source_selector_edit_primary_selection` is deprecated and should not be used in newly-written code.

Allows the user to rename the primary selected source by opening an entry box directly in `selector` .

#### Parameters

selector | An ESourceSelector widget |

Since: 2.26

### e_source_selector_ref_primary_selection ()

    ESource *
    e_source_selector_ref_primary_selection
                                   (ESourceSelector *selector);

`e_source_selector_ref_primary_selection` is deprecated and should not be used in newly-written code.

Get the primary selected source. The primary selection is the one that is highlighted through the normal GtkTreeView selection mechanism (as opposed to the "normal" selection, which is the set of source whose checkboxes are checked).

The returned ESource is referenced for thread-safety and must be unreferenced with `g_object_unref()` when finished with it.

#### Parameters

selector | An ESourceSelector widget |

#### Returns

The selected source.

Since: 3.6

### e_source_selector_set_primary_selection ()

    void
    e_source_selector_set_primary_selection
                                   (ESourceSelector *selector,
                                    ESource *source);

`e_source_selector_set_primary_selection` is deprecated and should not be used in newly-written code.

Highlights `source` in `selector` . The highlighted ESource is called the primary selection.

Do not confuse this function with `e_source_selector_select_source()`, which activates the check box next to an ESource's display name in `selector` . This function does not alter the check box.

#### Parameters

selector | an ESourceSelector widget |
source | an ESource to select |

### e_source_selector_ref_source_by_iter ()

    ESource *
    e_source_selector_ref_source_by_iter (ESourceSelector *selector,
                                          GtkTreeIter *iter);

`e_source_selector_ref_source_by_iter` is deprecated and should not be used in newly-written code.

Returns the ESource object at `iter` .

The returned ESource is referenced for thread-safety and must be unreferenced with `g_object_unref()` when finished with it.

#### Parameters

selector | an ESourceSelector |
iter | a GtkTreeIter |

#### Returns

the ESource object at `iter` , or `NULL`

Since: 3.8

### e_source_selector_ref_source_by_path ()

    ESource *
    e_source_selector_ref_source_by_path (ESourceSelector *selector,
                                          GtkTreePath *path);

`e_source_selector_ref_source_by_path` is deprecated and should not be used in newly-written code.

Returns the ESource object at `path` , or `NULL` if `path` is invalid.

The returned ESource is referenced for thread-safety and must be unreferenced with `g_object_unref()` when finished with it.

#### Parameters

selector | an ESourceSelector |
path | a GtkTreePath |

#### Returns

the ESource object at `path` , or `NULL`

Since: 3.6

### e_source_selector_queue_write ()

    void
    e_source_selector_queue_write (ESourceSelector *selector,
                                   ESource *source);

`e_source_selector_queue_write` is deprecated and should not be used in newly-written code.

Queues a main loop idle callback to write changes to `source` back to the D-Bus registry service.

#### Parameters

selector | an ESourceSelector |
source | an ESource with changes to be written |

Since: 3.6

### e_source_selector_update_row ()

    void
    e_source_selector_update_row (ESourceSelector *selector,
                                  ESource *source);

`e_source_selector_update_row` is deprecated and should not be used in newly-written code.

Updates the corresponding GtkTreeModel row for `source` .

This function is public so it can be called from subclasses like EClientSelector.

#### Parameters

selector | an ESourceSelector |
source | an ESource |

Since: 3.8

### e_source_selector_update_all_rows ()

    void
    e_source_selector_update_all_rows (ESourceSelector *selector);

`e_source_selector_update_all_rows` is deprecated and should not be used in newly-written code.

Calls `e_source_selector_update_row()` for each ESource being shown by `selector` , according to the “extension_name” property.

#### Parameters

selector | an ESourceSelector |

Since: 3.10

### e_source_selector_set_source_tooltip ()

    void
    e_source_selector_set_source_tooltip (ESourceSelector *selector,
                                          ESource *source,
                                          const gchar *tooltip);

`e_source_selector_set_source_tooltip` is deprecated and should not be used in newly-written code.

Updates tooltip for the given `source` .

#### Parameters

selector | an ESourceSelector |
source | an ESource for which to set the tooltip |

Since: 3.16

### e_source_selector_dup_source_tooltip ()

    gchar *
    e_source_selector_dup_source_tooltip (ESourceSelector *selector,
                                          ESource *source);

`e_source_selector_dup_source_tooltip` is deprecated and should not be used in newly-written code.

#### Parameters

selector | an ESourceSelector |
source | an ESource for which to read the tooltip |

#### Returns

Current tooltip for the given `source` . Free the returned string with `g_free()` when done with it.

Since: 3.16

### e_source_selector_set_source_is_busy ()

    void
    e_source_selector_set_source_is_busy (ESourceSelector *selector,
                                          ESource *source,
                                          gboolean is_busy);

`e_source_selector_set_source_is_busy` is deprecated and should not be used in newly-written code.

Updates the is-busy flag status for the given `source` .

#### Parameters

selector | an ESourceSelector |
source | an ESource for which to set the is-busy status |

Since: 3.16

### e_source_selector_get_source_is_busy ()

    gboolean
    e_source_selector_get_source_is_busy (ESourceSelector *selector,
                                          ESource *source);

`e_source_selector_get_source_is_busy` is deprecated and should not be used in newly-written code.

#### Parameters

selector | an ESourceSelector |
source | an ESource for which to read the is-busy status |

#### Returns

Current is-busy flag status for the given `source` .

Since: 3.16

### e_source_selector_manage_groups ()

    gboolean
    e_source_selector_manage_groups (ESourceSelector *selector);

`e_source_selector_manage_groups` is deprecated and should not be used in newly-written code.

Manages list of groups, like their order in the source selector, and a hidden property of the group.

#### Parameters

selector | an ESourceSelector |

#### Returns

Whether user confirmed changes in the dialog.

Since: 3.20

### e_source_selector_save_groups_setup ()

    gboolean
    e_source_selector_save_groups_setup (ESourceSelector *selector,
                                         GKeyFile *key_file);

`e_source_selector_save_groups_setup` is deprecated and should not be used in newly-written code.

Stores current setup of the groups in the `key_file` .

Use `e_source_selector_load_groups_setup()` to pass the settings back to the `selector` .

#### Parameters

selector | an ESourceSelector |
key_file | a GKeyFile to store the sgroups setup to |

#### Returns

Whether the saved values are different, aka whether it's required to store the changes.

Since: 3.20

### e_source_selector_load_groups_setup ()

    void
    e_source_selector_load_groups_setup (ESourceSelector *selector,
                                         GKeyFile *key_file);

`e_source_selector_load_groups_setup` is deprecated and should not be used in newly-written code.

Loads setup of the groups from the `key_file` .

Use `e_source_selector_save_groups_setup()` to store the settings of the `selector` .

#### Parameters

selector | an ESourceSelector |
key_file | a GKeyFile to load the groups setup from |

Since: 3.20

## Types and Values

### E_SOURCE_SELECTOR_GROUPS_SETUP_NAME

    #define E_SOURCE_SELECTOR_GROUPS_SETUP_NAME "SourceSelector"

`E_SOURCE_SELECTOR_GROUPS_SETUP_NAME` is deprecated and should not be used in newly-written code.